////////////////////////////////////////////////////////////////////////////////////////////////
// ʂ̃fhԂGtFNg
////////////////////////////////////////////////////////////////////////////////////////////////
// ANZɑgݍޏꍇ͂KXύXĂD
float3 MirrorPos = float3( 0.0, 0.0, 0.0 );    // [JWnɂ鋾ʏ̔Cӂ̍W(ANZ_Ẅ_)
float3 MirrorNormal = float3( 0.0, 1.0, 0.0 ); // [JWnɂ鋾ʂ̖@xNg

///////////////////////////////////////////////////////////////////////////////////////////////
// ʍWϊp[^
float4x4 MirrorWorldMatrix: CONTROLOBJECT < string Name = "(OffscreenOwner)"; >; // ʃANZ̃[hϊs

// [hWnɂ鋾ʒuւ̕ϊ
static float3 WldMirrorPos = mul( float4(MirrorPos, 1.0f), MirrorWorldMatrix ).xyz;
static float3 WldMirrorNormal = normalize( mul( MirrorNormal, (float3x3)MirrorWorldMatrix ) );

// W̋ϊ
float4 TransMirrorPos( float4 Pos )
{
    Pos.xyz -= WldMirrorNormal * 2.0f * dot(WldMirrorNormal, Pos.xyz - WldMirrorPos);
    return Pos;
}

float3 CameraPosition : POSITION  < string Object = "Camera"; >;

// ʕ\(WƃJʂ̕\ɂ鎞{)
float IsFace( float4 Pos )
{
    return min( dot(Pos.xyz-WldMirrorPos, WldMirrorNormal),
                dot(CameraPosition-WldMirrorPos, WldMirrorNormal) );
}

///////////////////////////////////////////////////////////////////////////////////////////////

// Wϊs
float4x4 ViewProjMatrix : VIEWPROJECTION;
float4x4 WorldMatrix    : WORLD;
float4x4 ViewMatrix     : VIEW;
float4x4 ProjMatrix     : PROJECTION;

float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;
static float alpha1 = MaterialDiffuse.a;

bool use_texture;  //eNX`̗L

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state
{
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};


////////////////////////////////////////////////////////////////////////////////////////////////
//MMMΉ

#ifndef MIKUMIKUMOVING
    struct VS_INPUT{
        float4 Pos    : POSITION;
        float2 Tex    : TEXCOORD0;
    };
    #define GETPOS (IN.Pos)
    #define GET_VPMAT(p) (ViewProjMatrix)
#else
    #define VS_INPUT  MMM_SKINNING_INPUT
    #define GETPOS MMM_SkinnedPosition(IN.Pos, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1)
    #define GET_VPMAT(p) (MMM_IsDinamicProjection ? mul(ViewMatrix, MMM_DynamicFov(ProjMatrix, length(CameraPosition-p.xyz))) : ViewProjMatrix)
#endif

////////////////////////////////////////////////////////////////////////////////////////////////

struct VS_OUTPUT
{
    float4 Pos   : POSITION;    // ˉeϊW
    float2 Tex   : TEXCOORD1;   // eNX`
    float4 WPos  : TEXCOORD2;   // [hW
};

// _VF[_
VS_OUTPUT Basic_VS(VS_INPUT IN)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    // [hWϊ
    float4 Pos = mul( GETPOS, WorldMatrix );
    Out.WPos = Pos; // [hW

    // ʒuւ̍Wϊ
    Pos = TransMirrorPos( Pos ); // ϊ

    // J_̃r[ˉeϊ
    Out.Pos = mul( Pos, GET_VPMAT(Pos) );
    Out.Pos.x = -Out.Pos.x; // |SԂȂ悤ɍE]ɂĕ`

    // eNX`W
    Out.Tex = IN.Tex;

    return Out;
}

float4 Basic_PS( VS_OUTPUT IN ) : COLOR0
{
    // ʂ̗ɂ镔ʂ͋\Ȃ
    clip( IsFace( IN.WPos ) );

    float alpha = alpha1;
    if ( use_texture ) alpha *= tex2D( ObjTexSampler, IN.Tex ).a;

    return float4(0.0, 0.0, 0.0, alpha);
}

//ZtVhEȂ
technique Mask < string MMDPass = "object"; > {
    pass Single_Pass { 
        VertexShader = compile vs_2_0 Basic_VS();
        PixelShader = compile ps_2_0 Basic_PS(); 
    }
}

//ZtVhE
technique MaskSS < string MMDPass = "object_ss"; > {
    pass Single_Pass { 
        VertexShader = compile vs_2_0 Basic_VS();
        PixelShader = compile ps_2_0 Basic_PS(); 
    }
}

//e֊s͕`悵Ȃ
technique EdgeTec < string MMDPass = "edge"; > { }
technique ShadowTec < string MMDPass = "shadow"; > { }
technique ZplotTec < string MMDPass = "zplot"; > { }

