////////////////////////////////////////////////////////////////////////////////////////////////
//
// Material Selector for ObjectLuminous.fx
//    IuWFNg̋Ȃfނ̐FyєFŕ`悵܂
//    MMEffectGtFNgWL_EmitterRT^uA
//       ̔ގԍw肵ăfɓKp
//       邢́ATuZbgWJĎw肷ގɓKp܂
//
////////////////////////////////////////////////////////////////////////////////////////////////

// ގԍ
#define TargetSubset "0-1000"

//F (RGBAevf 0.0`1.0)
float3 Emittion_Color
<
   string UIName = "Emittion Color1";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 1.0;
> = float3( 0.0, 0.0, 0.0 );

//QC
float Gain
<
   string UIName = "Gain";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.0; float UIMax = 5.0;
> = float( 1.0 );


///////////////////////////////////////////////////////////////////////////////////////////////
// ANZɑgݍޏꍇ͂KXύXĂD
float3 MirrorPos = float3( 0.0, 0.0, 0.0 );    // [JWnɂ鋾ʏ̔Cӂ̍W(ANZ_Ẅ_)
float3 MirrorNormal = float3( 0.0, 1.0, 0.0 ); // [JWnɂ鋾ʂ̖@xNg


// Ȃl͂牺͂Ȃł
///////////////////////////////////////////////////////////////////////////////////////////////
// ʍWϊp[^
float4x4 MirrorWorldMatrix: CONTROLOBJECT < string Name = "(OffscreenOwner)"; >; // ʃANZ̃[hϊs

// [hWnɂ鋾ʒuւ̕ϊ
static float3 WldMirrorPos = mul( float4(MirrorPos, 1.0f), MirrorWorldMatrix ).xyz;
static float3 WldMirrorNormal = normalize( mul( MirrorNormal, (float3x3)MirrorWorldMatrix ) );

// W̋ϊ
float4 TransMirrorPos( float4 Pos )
{
    Pos.xyz -= WldMirrorNormal * 2.0f * dot(WldMirrorNormal, Pos.xyz - WldMirrorPos);
    return Pos;
}

float3 CameraPosition : POSITION  < string Object = "Camera"; >;

// ʕ\(WƃJʂ̕\ɂ鎞{)
float IsFace( float4 Pos )
{
    return min( dot(Pos.xyz-WldMirrorPos, WldMirrorNormal),
                dot(CameraPosition-WldMirrorPos, WldMirrorNormal) );
}

///////////////////////////////////////////////////////////////////////////////////////////////

// Wϊs
float4x4 ViewProjMatrix : VIEWPROJECTION;
float4x4 WorldMatrix    : WORLD;
float4x4 ViewMatrix     : VIEW;
float4x4 ProjMatrix     : PROJECTION;

// }eAF
float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float3   MaterialSpecular  : SPECULAR < string Object = "Geometry"; >;
float    SpecularPower     : SPECULARPOWER < string Object = "Geometry"; >;

bool use_texture;    //eNX`̗L
bool use_spheremap;  //eNX`̗L
bool spadd;    // XtBA}bvZtO


// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state
{
    texture = <ObjectTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

// IuWFNg̃XtBA}bveNX`B
texture ObjectSphereMap : MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state
{
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};


////////////////////////////////////////////////////////////////////////////////////////////////
//MMMΉ

#ifndef MIKUMIKUMOVING
    struct VS_INPUT{
        float4 Pos    : POSITION;
        float3 Normal : NORMAL;
        float2 Tex    : TEXCOORD0;
    };
    #define GETPOS (IN.Pos)
    #define GET_VPMAT(p) (ViewProjMatrix)
#else
    #define VS_INPUT  MMM_SKINNING_INPUT
    #define GETPOS MMM_SkinnedPosition(IN.Pos, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1)
    #define GET_VPMAT(p) (MMM_IsDinamicProjection ? mul(ViewMatrix, MMM_DynamicFov(ProjMatrix, length(CameraPosition-p.xyz))) : ViewProjMatrix)
#endif


////////////////////////////////////////////////////////////////////////////////////////////////

struct VS_OUTPUT {
    float4 Pos   : POSITION;
    float2 Tex   : TEXCOORD0;   // eNX`
    float2 SpTex : TEXCOORD1;   // XtBA}bveNX`W
    float4 WPos  : TEXCOORD2;   // ̃[hW
    float4 Color : COLOR0;      // fBt[YF
};

// _VF[_
VS_OUTPUT VS_MirrorSelected(VS_INPUT IN)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;

    // [hWϊ
    float4 Pos = mul( GETPOS, WorldMatrix );
    Out.WPos = Pos; // [hW

    // ʒuւ̍Wϊ
    Pos = TransMirrorPos( Pos ); // ϊ

    // J_̃r[ˉeϊ
    Out.Pos = mul( Pos, GET_VPMAT(Pos) );
    Out.Pos.x = -Out.Pos.x; // |SԂȂ悤ɍE]ɂĕ`

    // fBt[YF{ArGgF vZ
    Out.Color = MaterialDiffuse;
    Out.Color.rgb += MaterialEmmisive / 2;
    Out.Color.rgb *= 0.5;

    // eNX`W
    Out.Tex = IN.Tex;

    // XtBA}bveNX`W
    float3 Normal = normalize( mul( IN.Normal, (float3x3)WorldMatrix ) );
    float2 NormalWV = mul( Normal, (float3x3)ViewMatrix ).xy;
    Out.SpTex.x = NormalWV.x * 0.5f + 0.5f;
    Out.SpTex.y = NormalWV.y * -0.5f + 0.5f;

    return Out;
}

//sNZVF[_
float4 PS_MirrorSelected(VS_OUTPUT IN) : COLOR
{
    // ʂ̗ɂ镔ʂ͋\Ȃ
    clip( IsFace( IN.WPos ) );

    float4 Color = IN.Color;
    if ( use_texture ) {
        // eNX`Kp
        Color *= tex2D( ObjTexSampler, IN.Tex );
    }
    if ( use_spheremap ) {
        // XtBA}bvKp
        if(spadd) Color.rgb += tex2D(ObjSphareSampler,IN.SpTex).rgb;
        else      Color.rgb *= tex2D(ObjSphareSampler,IN.SpTex).rgb;
    }
    Color.rgb += Emittion_Color;
    Color.rgb *= (Gain * Color.a);
    
    return Color;
}

float4 PS_Black(VS_OUTPUT IN) : COLOR
{
    // ʂ̗ɂ镔ʂ͋\Ȃ
    clip( IsFace( IN.WPos ) );

    float alpha = IN.Color.a;
    if ( use_texture ) alpha *= tex2D( ObjTexSampler, IN.Tex ).a;

    return float4(0.0, 0.0, 0.0, alpha);
}


////////////////////////////////////////////////////////////////////////////////////////////////
//eNjbN

//ZtVhEȂ
technique Tec1 < string MMDPass = "object"; string Subset = TargetSubset; >
{
    pass Single_Pass {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 VS_MirrorSelected();
        PixelShader  = compile ps_2_0 PS_MirrorSelected();
    }
}

technique Mask < string MMDPass = "object"; >
{
    pass Single_Pass {
        AlphaBlendEnable = TRUE;
        VertexShader = compile vs_2_0 VS_MirrorSelected();
        PixelShader  = compile ps_2_0 PS_Black();
    }
}

//ZtVhE
technique Tec1SS < string MMDPass = "object_ss"; string Subset = TargetSubset; >
{
    pass Single_Pass {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 VS_MirrorSelected();
        PixelShader  = compile ps_2_0 PS_MirrorSelected();
    }
}

technique MaskSS < string MMDPass = "object_ss"; >
{
    pass Single_Pass {
        AlphaBlendEnable = TRUE;
        VertexShader = compile vs_2_0 VS_MirrorSelected();
        PixelShader  = compile ps_2_0 PS_Black();
    }
}

//e֊s͕`悵Ȃ
technique EdgeTec < string MMDPass = "edge"; > { }
technique ShadowTec < string MMDPass = "shadow"; > { }

